'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactSyntaxHighlighter = require('react-syntax-highlighter');

var _reactSyntaxHighlighter2 = _interopRequireDefault(_reactSyntaxHighlighter);

var _reactResizeDetector = require('react-resize-detector');

var _reactResizeDetector2 = _interopRequireDefault(_reactResizeDetector);

var _prettier = require('prettier');

var _prettier2 = _interopRequireDefault(_prettier);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PrettierCodeTag = function (_React$Component) {
  _inherits(PrettierCodeTag, _React$Component);

  function PrettierCodeTag() {
    _classCallCheck(this, PrettierCodeTag);

    var _this = _possibleConstructorReturn(this, (PrettierCodeTag.__proto__ || Object.getPrototypeOf(PrettierCodeTag)).call(this));

    _this.me = null;
    _this.state = {
      charWidth: 8,
      charHeight: 16,
      textWidth: 30
    };
    return _this;
  }

  _createClass(PrettierCodeTag, [{
    key: 'updateSize',
    value: function updateSize(width, height) {
      this.setState({ textWidth: width });
    }
  }, {
    key: 'updateFontSize',
    value: function updateFontSize(width, height) {
      if (!this.cw) {
        return setTimeout(this.updateFontSize.bind(this), 100);
      } else {
        width = this.cw.querySelector('.single-character-measurement code').getBoundingClientRect().width;
        height = this.cw.querySelector('.single-character-measurement code').getBoundingClientRect().height;
      }
      this.setState({ charWidth: width, charHeight: height });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      // Extract props
      var _props = this.props,
          debug = _props.debug,
          code = _props.code,
          options = _props.options,
          subtract = _props.subtract,
          syntaxHighlighterProps = _objectWithoutProperties(_props, ['debug', 'code', 'options', 'subtract']);
      // The subtract prop lets us offset for line number width manually


      subtract = subtract ? parseInt(subtract) : 0;
      // This kinda takes into account the 0.5em margin on both sides
      var columns = Math.floor(this.state.textWidth / this.state.charWidth) - 2 - subtract;
      // prettier-ignore
      debug = this.state.textWidth + ' / ' + this.state.charWidth + ' = ' + columns + ' chars\n' + '-'.repeat(Math.max(1, columns - 1)) + '*';
      options = Object.assign({}, options, { printWidth: columns });
      code = _prettier2.default.format(code, options);
      return _react2.default.createElement(
        'div',
        {
          style: {
            width: '100%'
          },
          ref: function ref(el) {
            return _this2.el = el;
          }
        },
        _react2.default.createElement(_reactResizeDetector2.default, {
          handleWidth: true,
          onResize: this.updateSize.bind(this)
        }),
        _react2.default.createElement(
          'div',
          {
            className: 'single-character-measurement',
            style: {
              visibility: 'hidden',
              position: 'absolute',
              top: 0,
              left: 0
            },
            ref: function ref(el) {
              return _this2.cw = el;
            }
          },
          _react2.default.createElement(_reactResizeDetector2.default, {
            handleWidth: true,
            onResize: this.updateFontSize.bind(this)
          }),
          _react2.default.createElement(
            _reactSyntaxHighlighter2.default,
            _extends({
              language: 'javascript'
            }, syntaxHighlighterProps, {
              showLineNumbers: false
            }),
            'M'
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'responsive-prettier-code-box' },
          _react2.default.createElement(
            _reactSyntaxHighlighter2.default,
            _extends({ language: 'javascript' }, syntaxHighlighterProps),
            '' + (this.props.debug ? debug : code)
          )
        )
      );
    }
  }]);

  return PrettierCodeTag;
}(_react2.default.Component);

exports.default = PrettierCodeTag;